<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/15/16
 * Time: 8:24 AM
 */

namespace qfq;

require_once(__DIR__ . '/AbstractDatabaseTest.php');
require_once(__DIR__ . '/../../qfq/Delete.php');

/**
 * Class DeleteTest
 * @package qfq
 */
class DeleteTest extends \AbstractDatabaseTest {

    /**
     * @expectedException \qfq\CodeException
     */
    public function testProcessException() {

        $delete = new Delete(true);

        // empty 'form' not allowed
        $delete->process('', 123);
    }

    /**
     * @expectedException \qfq\CodeException
     */
    public function testProcessException2() {

        $delete = new Delete(true);

        // empty record id not allowed
        $formName = 'Person';
        $delete->process($formName, '');
    }

    /**
     * @expectedException \qfq\CodeException
     */
    public function testProcessException3() {

        $delete = new Delete(true);
        $formName = 'Person';

        // record id = 0 not allowed
        $delete->process($formName, 0);
    }

    /**
     * @expectedException \qfq\CodeException
     */
    public function testProcessException4() {

        $delete = new Delete(true);

        // unknown table not allowed
        $form[F_TABLE_NAME] = 'UnknownTable';
        $delete->process($form, 0);
    }

    /**
     */
    public function testProcessRecordNotFound() {

        $delete = new Delete(true);

        // unknown table not allowed
        $form[F_TABLE_NAME] = 'Person';
//        $rc = $delete->process($form, 100);
//
//        $this->assertEquals(false, $rc);
//
//        $expect = ['content' => "Record 100 not found in table 'Person'.", 'errorCode' => 1066];
//        $this->assertEquals($expect);
    }

    /**
     */
    public function testProcess() {

        $delete = new Delete(true);

        // unknown table not allowed
        $form[F_TABLE_NAME] = 'Person';
//        $rc = $delete->process($form, 1);
//
//        $this->assertEquals(true, $rc);
//
//
//        $count = $this->db->sql('SELECT COUNT(id) FROM Person', ROW_IMPLODE_ALL);
//        $this->assertEquals('1', $count);

    }


    protected function setUp() {

        $this->store = Store::getInstance('form=TestFormName', true);
        parent::setUp();

        $this->store->setVar('form', 'TestFormName', STORE_TYPO3);
        $this->store->setVar(SYSTEM_SITE_PATH, '/tmp', STORE_SYSTEM, true);

        $this->executeSQLFile(__DIR__ . '/fixtures/Generic.sql', true);
    }

}
